---
title: Create an incident user-defined role
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create an incident user-defined role{% #create-an-incident-user-defined-role %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                  |
| ----------------- | ----------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/incidents/config/user-defined-roles |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/incidents/config/user-defined-roles |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/incidents/config/user-defined-roles      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/incidents/config/user-defined-roles      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/incidents/config/user-defined-roles  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/incidents/config/user-defined-roles |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/incidents/config/user-defined-roles     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/incidents/config/user-defined-roles |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/incidents/config/user-defined-roles |

### Overview

Create a new user-defined role for incidents.

OAuth apps require the `incident_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#incidents) to access this endpoint.



### Arguments

#### Query Strings

| Name    | Type   | Description                                                           |
| ------- | ------ | --------------------------------------------------------------------- |
| include | string | Comma-separated list of related resources to include in the response. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field  | Field                           | Type    | Description                                                                                  |
| ------------- | ------------------------------- | ------- | -------------------------------------------------------------------------------------------- |
|               | data [*required*]          | object  | Data for creating an incident user-defined role.                                             |
| data          | attributes [*required*]    | object  | Attributes for creating an incident user-defined role.                                       |
| attributes    | description                     | string  | A description of the user-defined role.                                                      |
| attributes    | name [*required*]          | string  | The name of the user-defined role.                                                           |
| attributes    | policy                          | object  | Policy configuration for a user-defined role.                                                |
| policy        | is_single [*required*]     | boolean | Whether this role can only be assigned to one responder at a time.                           |
| data          | relationships [*required*] | object  | Relationships for creating a user-defined role.                                              |
| relationships | incident_type [*required*] | object  | Relationship to an incident type for a user-defined role.                                    |
| incident_type | data [*required*]          | object  | Data for the incident type relationship of a user-defined role.                              |
| data          | id [*required*]            | uuid    | The ID of the incident type.                                                                 |
| data          | type [*required*]          | string  | The type of the resource.                                                                    |
| data          | type [*required*]          | enum    | Incident user-defined role resource type. Allowed enum values: `incident_user_defined_roles` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "The technical lead for the incident.",
      "name": "Tech Lead",
      "policy": {
        "is_single": true
      }
    },
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000001",
          "type": "incident_types"
        }
      }
    },
    "type": "incident_user_defined_roles"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response with a single incident user-defined role.

| Parent field                  | Field                         | Type            | Description                                                                                                                                                                                                                                                           |
| ----------------------------- | ----------------------------- | --------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                               | data [*required*]        | object          | Data for an incident user-defined role response.                                                                                                                                                                                                                      |
| data                          | attributes [*required*]  | object          | Attributes of an incident user-defined role.                                                                                                                                                                                                                          |
| attributes                    | created [*required*]     | date-time       | Timestamp when the role was created.                                                                                                                                                                                                                                  |
| attributes                    | description                   | string          | A description of the user-defined role.                                                                                                                                                                                                                               |
| attributes                    | modified [*required*]    | date-time       | Timestamp when the role was last modified.                                                                                                                                                                                                                            |
| attributes                    | name [*required*]        | string          | The name of the user-defined role.                                                                                                                                                                                                                                    |
| attributes                    | policy [*required*]      | object          | Policy configuration for a user-defined role.                                                                                                                                                                                                                         |
| policy                        | is_single [*required*]   | boolean         | Whether this role can only be assigned to one responder at a time.                                                                                                                                                                                                    |
| data                          | id [*required*]          | uuid            | The ID of the user-defined role.                                                                                                                                                                                                                                      |
| data                          | relationships                 | object          | Relationships of a user-defined role response.                                                                                                                                                                                                                        |
| relationships                 | created_by_user               | object          | Relationship to user.                                                                                                                                                                                                                                                 |
| created_by_user               | data [*required*]        | object          | Relationship to user object.                                                                                                                                                                                                                                          |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                                                                                                                                                         |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                                                                                                                                                     |
| relationships                 | incident_type                 | object          | Relationship to an incident type for a user-defined role.                                                                                                                                                                                                             |
| incident_type                 | data [*required*]        | object          | Data for the incident type relationship of a user-defined role.                                                                                                                                                                                                       |
| data                          | id [*required*]          | uuid            | The ID of the incident type.                                                                                                                                                                                                                                          |
| data                          | type [*required*]        | string          | The type of the resource.                                                                                                                                                                                                                                             |
| relationships                 | last_modified_by_user         | object          | Relationship to user.                                                                                                                                                                                                                                                 |
| last_modified_by_user         | data [*required*]        | object          | Relationship to user object.                                                                                                                                                                                                                                          |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                                                                                                                                                         |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                                                                                                                                                     |
| data                          | type [*required*]        | enum            | Incident user-defined role resource type. Allowed enum values: `incident_user_defined_roles`                                                                                                                                                                          |
|                               | included                      | [ <oneOf>] | Included resources for an incident user-defined role response.                                                                                                                                                                                                        |
| included                      | <type=users>                  | object          | User object returned by the API.                                                                                                                                                                                                                                      |
| <type=users>                  | attributes                    | object          | Attributes of user object returned by the API.                                                                                                                                                                                                                        |
| attributes                    | email                         | string          | Email of the user.                                                                                                                                                                                                                                                    |
| attributes                    | handle                        | string          | Handle of the user.                                                                                                                                                                                                                                                   |
| attributes                    | icon                          | string          | URL of the user's icon.                                                                                                                                                                                                                                               |
| attributes                    | name                          | string          | Name of the user.                                                                                                                                                                                                                                                     |
| attributes                    | uuid                          | string          | UUID of the user.                                                                                                                                                                                                                                                     |
| <type=users>                  | id                            | string          | ID of the user.                                                                                                                                                                                                                                                       |
| <type=users>                  | type                          | enum            | Users resource type. Allowed enum values: `users`                                                                                                                                                                                                                     |
| included                      | <type=incident_types>         | object          | Incident type response data.                                                                                                                                                                                                                                          |
| <type=incident_types>         | attributes                    | object          | Incident type's attributes.                                                                                                                                                                                                                                           |
| attributes                    | configuration                 | object          | The incident-type-scoped behavior settings. All fields are optional on update. Any field omitted from a PATCH request keeps its current value. This object is read-only on the incident type resource itself and is only mutated through the update (PATCH) endpoint. |
| configuration                 | allow_incident_deletion       | boolean         | Whether incidents of this type can be deleted.                                                                                                                                                                                                                        |
| configuration                 | allow_workflows               | boolean         | Whether automation workflows can be triggered for incidents of this type.                                                                                                                                                                                             |
| configuration                 | create_message                | string          | An optional message shown to users when they declare an incident of this type.                                                                                                                                                                                        |
| configuration                 | editable_timestamps           | boolean         | Whether responders can edit incident timestamps for incidents of this type.                                                                                                                                                                                           |
| configuration                 | private_incidents             | boolean         | Whether responders can create private incidents of this type. This is an opt-in setting, distinct from `private_incidents_by_default`, which controls whether incidents are created private automatically.                                                            |
| configuration                 | private_incidents_by_default  | boolean         | Whether incidents of this type are created as private by default.                                                                                                                                                                                                     |
| configuration                 | slug_source                   | enum            | When set to `servicenow`, incidents will display the ServiceNow record ID instead of the public ID. If no ServiceNow integration exists, the public ID will be displayed. Allowed enum values: `default,servicenow`                                                   |
| configuration                 | test_incidents                | boolean         | Whether incidents of this type are treated as test incidents.                                                                                                                                                                                                         |
| attributes                    | createdAt                     | date-time       | Timestamp when the incident type was created.                                                                                                                                                                                                                         |
| attributes                    | createdBy                     | string          | A unique identifier that represents the user that created the incident type.                                                                                                                                                                                          |
| attributes                    | description                   | string          | Text that describes the incident type.                                                                                                                                                                                                                                |
| attributes                    | is_default                    | boolean         | If true, this incident type will be used as the default incident type if a type is not specified during the creation of incident resources.                                                                                                                           |
| attributes                    | lastModifiedBy                | string          | A unique identifier that represents the user that last modified the incident type.                                                                                                                                                                                    |
| attributes                    | modifiedAt                    | date-time       | Timestamp when the incident type was last modified.                                                                                                                                                                                                                   |
| attributes                    | name [*required*]        | string          | The name of the incident type.                                                                                                                                                                                                                                        |
| attributes                    | prefix                        | string          | The string that will be prepended to the incident title across the Datadog app.                                                                                                                                                                                       |
| <type=incident_types>         | id [*required*]          | string          | The incident type's ID.                                                                                                                                                                                                                                               |
| <type=incident_types>         | relationships                 | object          | The incident type's resource relationships.                                                                                                                                                                                                                           |
| relationships                 | created_by_user               | object          | Relationship to user.                                                                                                                                                                                                                                                 |
| created_by_user               | data [*required*]        | object          | Relationship to user object.                                                                                                                                                                                                                                          |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                                                                                                                                                         |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                                                                                                                                                     |
| relationships                 | google_meet_configuration     | object          | A reference to a Google Meet Configuration resource.                                                                                                                                                                                                                  |
| google_meet_configuration     | data [*required*]        | object          | The Google Meet configuration relationship data object.                                                                                                                                                                                                               |
| data                          | id [*required*]          | string          | The unique identifier of the Google Meet configuration.                                                                                                                                                                                                               |
| data                          | type [*required*]        | string          | The type of the Google Meet configuration.                                                                                                                                                                                                                            |
| relationships                 | last_modified_by_user         | object          | Relationship to user.                                                                                                                                                                                                                                                 |
| last_modified_by_user         | data [*required*]        | object          | Relationship to user object.                                                                                                                                                                                                                                          |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                                                                                                                                                         |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                                                                                                                                                     |
| relationships                 | microsoft_teams_configuration | object          | A reference to a Microsoft Teams Configuration resource.                                                                                                                                                                                                              |
| microsoft_teams_configuration | data [*required*]        | object          | The Microsoft Teams configuration relationship data object.                                                                                                                                                                                                           |
| data                          | id [*required*]          | string          | The unique identifier of the Microsoft Teams configuration.                                                                                                                                                                                                           |
| data                          | type [*required*]        | string          | The type of the Microsoft Teams configuration.                                                                                                                                                                                                                        |
| relationships                 | zoom_configuration            | object          | A reference to a Zoom configuration resource.                                                                                                                                                                                                                         |
| zoom_configuration            | data [*required*]        | object          | The Zoom configuration relationship data object.                                                                                                                                                                                                                      |
| data                          | id [*required*]          | string          | The unique identifier of the Zoom configuration.                                                                                                                                                                                                                      |
| data                          | type [*required*]        | string          | The type of the Zoom configuration.                                                                                                                                                                                                                                   |
| <type=incident_types>         | type [*required*]        | enum            | Incident type resource type. Allowed enum values: `incident_types`                                                                                                                                                                                                    |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created": "2024-01-01T00:00:00.000Z",
      "description": "The technical lead for the incident.",
      "modified": "2024-01-01T00:00:00.000Z",
      "name": "Tech Lead",
      "policy": {
        "is_single": true
      }
    },
    "id": "00000000-0000-0000-0000-000000000002",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000001",
          "type": "incident_types"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "incident_user_defined_roles"
  },
  "included": [
    {
      "attributes": {
        "email": "string",
        "handle": "string",
        "icon": "string",
        "name": "string",
        "uuid": "string"
      },
      "id": "string",
      "type": "users"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/incidents/config/user-defined-roles" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "The technical lead for the incident.",
      "name": "Tech Lead",
      "policy": {
        "is_single": true
      }
    },
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000001",
          "type": "incident_types"
        }
      }
    },
    "type": "incident_user_defined_roles"
  }
}
EOF 
                
##### 

```python
"""
Create an incident user-defined role returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.incident_user_defined_role_data_attributes_request import (
    IncidentUserDefinedRoleDataAttributesRequest,
)
from datadog_api_client.v2.model.incident_user_defined_role_data_request import IncidentUserDefinedRoleDataRequest
from datadog_api_client.v2.model.incident_user_defined_role_incident_type_relationship import (
    IncidentUserDefinedRoleIncidentTypeRelationship,
)
from datadog_api_client.v2.model.incident_user_defined_role_incident_type_relationship_data import (
    IncidentUserDefinedRoleIncidentTypeRelationshipData,
)
from datadog_api_client.v2.model.incident_user_defined_role_policy import IncidentUserDefinedRolePolicy
from datadog_api_client.v2.model.incident_user_defined_role_relationships_request import (
    IncidentUserDefinedRoleRelationshipsRequest,
)
from datadog_api_client.v2.model.incident_user_defined_role_request import IncidentUserDefinedRoleRequest
from datadog_api_client.v2.model.incident_user_defined_role_type import IncidentUserDefinedRoleType
from uuid import UUID

body = IncidentUserDefinedRoleRequest(
    data=IncidentUserDefinedRoleDataRequest(
        attributes=IncidentUserDefinedRoleDataAttributesRequest(
            description="The technical lead for the incident.",
            name="Tech Lead",
            policy=IncidentUserDefinedRolePolicy(
                is_single=True,
            ),
        ),
        relationships=IncidentUserDefinedRoleRelationshipsRequest(
            incident_type=IncidentUserDefinedRoleIncidentTypeRelationship(
                data=IncidentUserDefinedRoleIncidentTypeRelationshipData(
                    id=UUID("00000000-0000-0000-0000-000000000001"),
                    type="incident_types",
                ),
            ),
        ),
        type=IncidentUserDefinedRoleType.INCIDENT_USER_DEFINED_ROLES,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_incident_user_defined_role"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.create_incident_user_defined_role(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create an incident user-defined role returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_incident_user_defined_role".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

body = DatadogAPIClient::V2::IncidentUserDefinedRoleRequest.new({
  data: DatadogAPIClient::V2::IncidentUserDefinedRoleDataRequest.new({
    attributes: DatadogAPIClient::V2::IncidentUserDefinedRoleDataAttributesRequest.new({
      description: "The technical lead for the incident.",
      name: "Tech Lead",
      policy: DatadogAPIClient::V2::IncidentUserDefinedRolePolicy.new({
        is_single: true,
      }),
    }),
    relationships: DatadogAPIClient::V2::IncidentUserDefinedRoleRelationshipsRequest.new({
      incident_type: DatadogAPIClient::V2::IncidentUserDefinedRoleIncidentTypeRelationship.new({
        data: DatadogAPIClient::V2::IncidentUserDefinedRoleIncidentTypeRelationshipData.new({
          id: "00000000-0000-0000-0000-000000000001",
          type: "incident_types",
        }),
      }),
    }),
    type: DatadogAPIClient::V2::IncidentUserDefinedRoleType::INCIDENT_USER_DEFINED_ROLES,
  }),
})
p api_instance.create_incident_user_defined_role(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Create an incident user-defined role returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.IncidentUserDefinedRoleRequest{
		Data: datadogV2.IncidentUserDefinedRoleDataRequest{
			Attributes: datadogV2.IncidentUserDefinedRoleDataAttributesRequest{
				Description: *datadog.NewNullableString(datadog.PtrString("The technical lead for the incident.")),
				Name:        "Tech Lead",
				Policy: &datadogV2.IncidentUserDefinedRolePolicy{
					IsSingle: true,
				},
			},
			Relationships: datadogV2.IncidentUserDefinedRoleRelationshipsRequest{
				IncidentType: datadogV2.IncidentUserDefinedRoleIncidentTypeRelationship{
					Data: datadogV2.IncidentUserDefinedRoleIncidentTypeRelationshipData{
						Id:   uuid.MustParse("00000000-0000-0000-0000-000000000001"),
						Type: "incident_types",
					},
				},
			},
			Type: datadogV2.INCIDENTUSERDEFINEDROLETYPE_INCIDENT_USER_DEFINED_ROLES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateIncidentUserDefinedRole", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.CreateIncidentUserDefinedRole(ctx, body, *datadogV2.NewCreateIncidentUserDefinedRoleOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.CreateIncidentUserDefinedRole`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.CreateIncidentUserDefinedRole`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create an incident user-defined role returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleDataAttributesRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleDataRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleIncidentTypeRelationship;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleIncidentTypeRelationshipData;
import com.datadog.api.client.v2.model.IncidentUserDefinedRolePolicy;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleRelationshipsRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleRequest;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleResponse;
import com.datadog.api.client.v2.model.IncidentUserDefinedRoleType;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createIncidentUserDefinedRole", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    IncidentUserDefinedRoleRequest body =
        new IncidentUserDefinedRoleRequest()
            .data(
                new IncidentUserDefinedRoleDataRequest()
                    .attributes(
                        new IncidentUserDefinedRoleDataAttributesRequest()
                            .description("The technical lead for the incident.")
                            .name("Tech Lead")
                            .policy(new IncidentUserDefinedRolePolicy().isSingle(true)))
                    .relationships(
                        new IncidentUserDefinedRoleRelationshipsRequest()
                            .incidentType(
                                new IncidentUserDefinedRoleIncidentTypeRelationship()
                                    .data(
                                        new IncidentUserDefinedRoleIncidentTypeRelationshipData()
                                            .id(
                                                UUID.fromString(
                                                    "00000000-0000-0000-0000-000000000001"))
                                            .type("incident_types"))))
                    .type(IncidentUserDefinedRoleType.INCIDENT_USER_DEFINED_ROLES));

    try {
      IncidentUserDefinedRoleResponse result = apiInstance.createIncidentUserDefinedRole(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#createIncidentUserDefinedRole");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Create an incident user-defined role returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::CreateIncidentUserDefinedRoleOptionalParams;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleDataAttributesRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleDataRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleIncidentTypeRelationship;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleIncidentTypeRelationshipData;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRolePolicy;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleRelationshipsRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleRequest;
use datadog_api_client::datadogV2::model::IncidentUserDefinedRoleType;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = IncidentUserDefinedRoleRequest::new(IncidentUserDefinedRoleDataRequest::new(
        IncidentUserDefinedRoleDataAttributesRequest::new("Tech Lead".to_string())
            .description(Some("The technical lead for the incident.".to_string()))
            .policy(IncidentUserDefinedRolePolicy::new(true)),
        IncidentUserDefinedRoleRelationshipsRequest::new(
            IncidentUserDefinedRoleIncidentTypeRelationship::new(
                IncidentUserDefinedRoleIncidentTypeRelationshipData::new(
                    Uuid::parse_str("00000000-0000-0000-0000-000000000001").expect("invalid UUID"),
                    "incident_types".to_string(),
                ),
            ),
        ),
        IncidentUserDefinedRoleType::INCIDENT_USER_DEFINED_ROLES,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateIncidentUserDefinedRole", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api
        .create_incident_user_defined_role(
            body,
            CreateIncidentUserDefinedRoleOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create an incident user-defined role returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createIncidentUserDefinedRole"] = true;
const apiInstance = new v2.IncidentsApi(configuration);

const params: v2.IncidentsApiCreateIncidentUserDefinedRoleRequest = {
  body: {
    data: {
      attributes: {
        description: "The technical lead for the incident.",
        name: "Tech Lead",
        policy: {
          isSingle: true,
        },
      },
      relationships: {
        incidentType: {
          data: {
            id: "00000000-0000-0000-0000-000000000001",
            type: "incident_types",
          },
        },
      },
      type: "incident_user_defined_roles",
    },
  },
};

apiInstance
  .createIncidentUserDefinedRole(params)
  .then((data: v2.IncidentUserDefinedRoleResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
